﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System.IO;
using System.Data;


namespace dBase {
    public class DBase {    //[StructLayout(LayoutKind.Explicit)]
                            //struct StructType {
                            //    [FieldOffset(0)]
                            //    public string FileDate;
                            //    [FieldOffset(8)]
                            //    public string FileTime;
                            //    [FieldOffset(16)]
                            //    public int Id1;
                            //    [FieldOffset(20)]
                            //    public string Id2;
                            //}

        class Dbheader3 {
            public Dbheader3() {
                dummy = new byte[20];
                id = 0;
                jahr = 0;
                tag = 0;
                monat = 0;
                anzrec = 0;
                headersize = 0;
                recsize = 0;
            }
            public byte id;        // 2=dbase2    3=dbase3    131=dBase3 mit Memofeld
            public byte jahr;      // datum
            public byte monat;
            public byte tag;
            public UInt32 anzrec;       // Anzahl der Datensaetze */
            public UInt16 headersize;      // Headergroesse in Byte */
            public UInt16 recsize;           // Laenge eines einzelnen Datensatzes
            public byte[] dummy;

            public void load1(BinaryReader inStream) {
                id = inStream.ReadByte();
                jahr = inStream.ReadByte();
                monat = inStream.ReadByte();
                tag = inStream.ReadByte();
                anzrec = inStream.ReadUInt32();
                headersize = inStream.ReadUInt16();
                recsize = inStream.ReadUInt16();
                for (int i = 0; i < 20; i++) {
                    inStream.ReadByte();
                }
            }

            public override String ToString() {
                return "Id: " + id + "\r\n" +
                    "Datum: " + jahr + "." + monat + "." + tag + "\r\n" +
                    "Anz-Datensätze: " + anzrec + "\r\n" +
                    "Headersize: " + headersize + "\r\n" +
                    "Länge eines Datensatzes: " + recsize;
            }

        }  // Dbheader3_rec


        class Field {

            private StringBuilder sb = new StringBuilder();

            public Field() {
                fieldname = "";  // 11 Zeichen
                typ = ' ';      //  C=String; N=Zahl; D=Datum; L=Boolean  M=Memotext
                fieldadr = 0;
                size = 0;
                nk = 0;
                offset = 0;
            }
            public String fieldname;  // 11 Zeichen
            public char typ;      //  C=String; N=Zahl; D=Datum; L=Boolean  M=Memotext
            public UInt32 fieldadr;       // Anzahl der Datensaetze */
            public byte size;
            public byte nk;
            // 14 dummys
            public UInt16 offset;

            public void load(BinaryReader inStream) {
                byte[] dummy = new byte[11];
                dummy = inStream.ReadBytes(11);
                fieldname = "";
                sb.Clear();
                foreach (byte b in dummy) {
                    if (b == 0)
                        break;
                    char ch = (char)b;
                    sb.Append(ch.ToString());
                }
                fieldname = sb.ToString();
                int nn = fieldname.Length;


                typ = (char)inStream.ReadByte();
                fieldadr = inStream.ReadUInt32();
                size = inStream.ReadByte();
                nk = inStream.ReadByte();
                if (typ == 'N') {
                    if (nk == 0)
                        typ = 'I';   // Integer
                    else
                        typ = 'F';   // float
                }
                for (int i = 0; i < 14; i++) {
                    inStream.ReadByte();
                }
            }

            public override String ToString() {
                return "fieldname: " + fieldname + "\r\n" +
                    "Typ: " + typ + "\r\n" +
                    "size: " + size + "\r\n" +
                    "nk: " + nk + "\r\n";

            }

        }  // Field_rec

        class Row {
            private StringBuilder sb = new StringBuilder();
            private byte[] dummy = new byte[255];
            public Row() {
            }

            public List<Object> attribs = new List<object>();

            public void printFields(StringBuilder sb) {
                foreach (Object obj in attribs) {
                    sb.Append(obj.ToString());
                    sb.Append("     ");
                }
                sb.AppendLine();
            }

            public void loadRow(BinaryReader inStream, List<Field> fieldlist) {
                String strValue;
                Decimal decValue;
                int intValue;
                foreach (Field fieldrec in fieldlist) {
                    switch (fieldrec.typ) {
                        case 'C':       // read size bytes
                            dummy = inStream.ReadBytes(fieldrec.size);
                            sb.Clear();
                            for (int i = 0; i < fieldrec.size; i++) {
                                sb.Append(((char)dummy[i]).ToString());
                            }
                            strValue = sb.ToString();
                            attribs.Add(strValue.Trim().Clone());
                            break;
                        case 'I':       // read size bytes Integer
                            dummy = inStream.ReadBytes(fieldrec.size);
                            sb.Clear();
                            for (int i = 0; i < fieldrec.size; i++) {
                                sb.Append(((char)dummy[i]).ToString());
                            }
                            strValue = sb.ToString();
                            if (int.TryParse(strValue, out intValue))
                                attribs.Add(intValue);
                            else
                                attribs.Add(0);
                            break;
                        case 'F':
                            // n nk         10/4        12345.1234
                            dummy = inStream.ReadBytes(fieldrec.size);
                            sb.Clear();
                            for (int i = 0; i < fieldrec.size; i++) {
                                sb.Append(((char)dummy[i]).ToString());
                            }
                            strValue = sb.ToString().Trim();
                            if (Decimal.TryParse(strValue,
                                System.Globalization.NumberStyles.AllowDecimalPoint | System.Globalization.NumberStyles.AllowLeadingSign,
                                System.Globalization.CultureInfo.InvariantCulture, out decValue))
                                attribs.Add(decValue);
                            else
                                attribs.Add(0.0);
                            break;
                        case 'L':
                            dummy = inStream.ReadBytes(fieldrec.size);
                            if (dummy.Equals("T") || dummy.Equals("True") || dummy.Equals("Wahr"))
                                attribs.Add(true);
                            else
                                attribs.Add(true);
                            break;
                        case 'D':
                            dummy = inStream.ReadBytes(fieldrec.size);
                            sb.Clear();
                            for (int i = 0; i < fieldrec.size; i++) {
                                sb.Append(((char)dummy[i]).ToString());
                            }
                            strValue = sb.ToString();
                            attribs.Add(strValue.Clone());
                            break;
                        case 'M':
                            break;
                    }  // switch
                }
            }
        }


        public String readdBaseFile2String(String filename) {
            const byte eof = 26;
            const byte rowIsDelete = 42; // *
            StringBuilder sb = new StringBuilder();
            List<Row> tabelle = new List<Row>();
            FileStream inFile = null;
            BinaryReader inStream = null;
            try {
                Dbheader3 header = new Dbheader3();
                inFile = new FileStream(filename, FileMode.Open);
                inStream = new BinaryReader(inFile);

                header.load1(inStream);
                sb.AppendLine("Header: ");
                sb.AppendLine(header.ToString());

                // Felder bestimmen
                List<Field> fieldlist = new List<Field>();
                Field field;
                while (true) {
                    field = new Field();
                    field.load(inStream);
                    String name = field.fieldname;
                    fieldlist.Add(field);
                    long position = inFile.Position;
                    // Preview für 
                    byte eoffield = inStream.ReadByte();
                    if (eoffield == 13) {
                        break;
                    }
                    else {
                        inFile.Seek(position, SeekOrigin.Begin);
                    }
                }
                sb.AppendLine();
                sb.AppendLine("Felder");
                foreach (Field fieldloop in fieldlist) {
                    sb.AppendLine(fieldloop.ToString());
                }
                byte flag;
                Row row;
                // vor jedem Datensatz steht das "Deleteflag   20=okay   46=gelöscht
                while (true) {
                    flag = inStream.ReadByte();   // space oder *    oder 1A
                    if (flag == eof) {
                        break;
                    }  // if (flag!=eof) {
                    row = new Row();
                    row.loadRow(inStream, fieldlist);
                    if (flag != rowIsDelete) {
                        tabelle.Add(row);
                    }
                    // 
                }  // while 

                int anzDatensaetze = tabelle.Count;
                sb.AppendLine("anzDatensaetze:" + anzDatensaetze);

                foreach (Row rowloop in tabelle) {
                    rowloop.printFields(sb);
                }

                inStream.Close();
                inFile.Close();
            }
            catch (Exception e) {
                sb.AppendLine("Fehler beim Öffnen der Datei:");
                sb.Append("  ");
                sb.AppendLine(filename);
                sb.AppendLine("Fehlermeldung:");
                sb.Append("  ");
                sb.AppendLine(e.ToString());
                inStream.Close();
                inFile.Close();
            }
            return sb.ToString();

        }




    }
}
